.486
.model  flat, stdcall  
option  casemap :none 

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

WinMain           PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc           PROTO :DWORD, :DWORD, :DWORD, :DWORD

.const

PictureW      equ 600
PictureH      equ 400

.data 


ClassName       db "Win32asm_class",0
DisplayName     db ".:. Blank Window .:.",0

MyRect      RECT <0,0,PictureW,PictureH>

black           dd 0000000h

.data? 
hInstance       dd ?
hmainDC         dd ?                                        
hmainbmp        dd ? 

.code 

start:
    invoke  GetModuleHandle, NULL
    mov     hInstance, eax
    xor edx,edx
    invoke  WinMain,hInstance,edx,edx,SW_SHOWDEFAULT
    invoke  ExitProcess,eax
WinMain   PROC hInst :DWORD,hPrevInst :DWORD,CmdLine :DWORD,CmdShow :DWORD

LOCAL   wc   :WNDCLASSEX
LOCAL   msg  :MSG
LOCAL   hwnd :HWND

        mov     wc.cbSize,sizeof WNDCLASSEX
        mov     wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.cbClsExtra,NULL


        mov     wc.cbWndExtra,NULL      
        push    hInst

        pop     wc.hInstance

        mov     wc.hbrBackground,COLOR_BTNFACE+4
        
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset ClassName             
        mov     wc.hIcon,NULL
        invoke  LoadCursor,NULL,IDC_ARROW				
        mov     wc.hCursor,eax      
        mov     wc.hIconSm,NULL
        
        invoke  RegisterClassEx, ADDR wc


        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,PictureW/2
        push    eax

        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,PictureH/2
        pop     ebx

        invoke  CreateWindowEx,WS_EX_LEFT,ADDR ClassName,ADDR DisplayName,
                WS_OVERLAPPEDWINDOW,ebx,eax,PictureW,PictureH,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        push eax

        mov edi, hwnd
        invoke  ShowWindow,edi,SW_SHOWNORMAL
        invoke  UpdateWindow,edi

_Start:
        invoke  GetMessage,ADDR msg,NULL,0,0
        test    eax, eax
        jz      _Exit
        invoke  TranslateMessage,ADDR msg
        invoke  DispatchMessage,ADDR msg

        jmp     _Start
_Exit:

        mov     eax,msg.wParam
        ret

WinMain         ENDP

WndProc  PROC   uses edx ecx ebx esi edi  hWnd :HWND,uMsg :DWORD,wParam :DWORD,lParam :DWORD


	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT

mov eax, uMsg  

    .IF eax == WM_PAINT 

invoke BeginPaint,hWnd, ADDR ps
mov    hdc,eax


invoke BitBlt, hdc, 0,0, PictureW,PictureH, hmainDC, 0, 0, SRCCOPY

invoke EndPaint,hWnd, ADDR ps

; -------------------------------------------------------------------------
    .ELSEIF     eax == WM_KEYDOWN

cmp wParam, VK_ESCAPE
je destroy


; -------------------------------------------------------------------------
    .ELSEIF     eax == WM_TIMER

invoke FillRect, hmainDC, addr MyRect,black
invoke RedrawWindow, hWnd, addr MyRect, 0, RDW_INVALIDATE	

; -------------------------------------------------------------------------
   .ELSEIF eax == WM_CREATE

invoke CreateSolidBrush,black
mov black,eax


  invoke GetDC, hWnd
  mov hdc, eax

  mov esi,PictureW
  mov edi,PictureH


  invoke CreateCompatibleDC, hdc
  mov dword ptr [hmainDC],eax

  invoke CreateCompatibleBitmap, hdc, esi, edi
  mov dword ptr [hmainbmp],eax

  invoke SelectObject, [hmainDC], eax
  
  invoke ReleaseDC,hWnd, hdc

; ====================================
; ====================================  

    .ELSEIF eax == WM_CLOSE
destroy:
invoke PostQuitMessage,NULL
invoke DeleteDC, [hmainDC]

invoke DeleteObject, [hmainbmp]
invoke DeleteObject, black

.ENDIF

xor eax,eax
invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
ret

WndProc         ENDP

END start